using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;

namespace Interop02
{
   /// <summary>
   /// Summary description for UserControl1.
   /// </summary>
   [ClassInterface(ClassInterfaceType.AutoDual)]
	[System.Runtime.InteropServices.Guid("DF7C5A5F-89D4-4ea1-84B2-9D3CD0B6B858")]
   public class UserControl1 : System.Windows.Forms.UserControl
   {
      private System.Windows.Forms.Button buttonClickTest;
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container components = null;

      public UserControl1()
      {
         // This call is required by the Windows.Forms Form Designer.
         InitializeComponent();
      }

      [ComRegisterFunction]
      static void ComRegister(Type t)
      {
         string keyName = @"CLSID\" + t.GUID.ToString("B");
         using (RegistryKey key = Registry.ClassesRoot.OpenSubKey(keyName, true))
         {
            key.CreateSubKey("Control").Close();
            using (RegistryKey subkey = key.CreateSubKey("MiscStatus"))
            {
               subkey.SetValue("", "131457");
            }
            using (RegistryKey subkey = key.CreateSubKey("TypeLib"))
            {
               Guid libid = Marshal.GetTypeLibGuidForAssembly(t.Assembly);
               subkey.SetValue("", libid.ToString("B"));
            }
            using (RegistryKey subkey = key.CreateSubKey("Version"))
            {
               Version ver = t.Assembly.GetName().Version;
               string version = string.Format("{0}.{1}", ver.Major, ver.Minor);
               if (version == "0.0")
                  version = "1.0";
               subkey.SetValue("", version);
            }
         }
      }

      [ComUnregisterFunction]
      static void ComUnregister(Type t)
      {
         Registry.ClassesRoot.DeleteSubKeyTree(@"CLSID\" + t.GUID.ToString("B"));
      }


      /// <summary>
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose( bool disposing )
      {
         if( disposing )
         {
            if(components != null)
            {
               components.Dispose();
            }
         }
         base.Dispose( disposing );
      }

      #region Component Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
		  this.buttonClickTest = new System.Windows.Forms.Button();
		  this.SuspendLayout();
		  // 
		  // buttonClickTest
		  // 
		  this.buttonClickTest.Location = new System.Drawing.Point(8, 8);
		  this.buttonClickTest.Name = "Click Test";
		  this.buttonClickTest.Size = new System.Drawing.Size(168, 16);
		  this.buttonClickTest.TabIndex = 0;
		  this.buttonClickTest.Text = "buttonClickTest";
		  this.buttonClickTest.Click += new System.EventHandler(this.buttonClickTest_Click);
		  // 
		  // UserControl1
		  // 
		  this.BackColor = System.Drawing.Color.IndianRed;
		  this.Controls.Add(this.buttonClickTest);
		  this.Name = "UserControl1";
		  this.Size = new System.Drawing.Size(264, 32);
		  this.ResumeLayout(false);

	  }
      #endregion

      private void buttonClickTest_Click(object sender, System.EventArgs e)
      {
         MessageBox.Show("Button Click handled by .NET");
      }
   }
}
